
var TextScript = `

//////////////////////////////////////////////////////////
// kkmserver
//////////////////////////////////////////////////////////

if (!window.KkmServer) {

    KkmServer = {

        Command: "",
        NumDevice: 0,
        IdCommand: undefined,

        DefaultSettings: {
            funCallBack: undefined,
            Timeout: 30,
            CashierName: "",
            CashierVATIN: "",
            SenderEmail: "",
            CheckProps: [],
            KeySubLicensing: ""
        },

        _QueryResponses: new Map(),
        _ListBarCodeEvent: new Set(),

        // Выполняет команду на KkmServer
        Execute: function (funCallBack = undefined, Data) {

            if (typeof (Data) == "string") Data = JSON.parse(Data);

            if (Data == undefined) {
                Data = KkmServer.extend({}, this, true, true);
            } else {
                Data = KkmServer.extend({}, Data, true, true);
            };

            if (funCallBack == undefined) {
                funCallBack = this.DefaultSettings.funCallBack;
            };
            if (Data.IdCommand == undefined) {
                Data.IdCommand = this.NewGuid();
            };
            if (Data.Timeout == undefined) {
                Data.Timeout = this.DefaultSettings.Timeout;
            };
            if (Data.KeySubLicensing == undefined && this.DefaultSettings.KeySubLicensing != "") {
                Data.KeySubLicensing = this.DefaultSettings.KeySubLicensing;
            };
            if (Data.Command == "" || Data.Command == undefined) {
                funCallBack({
                    Command: "<Не указано>",
                    Error: "Ошибка вызова: не заполнена команда",
                    Status: 2,
                    IdCommand: Data.IdCommand,
                });
                return this;
            };
            if (Data.Command == "GetRezult") {
                KkmServer._QueryResponses.set(Data.IdCommand + "GetRezult", funCallBack);
            } else {
                KkmServer._QueryResponses.set(Data.IdCommand, funCallBack);
            };
            window.postMessage({ Data: Data, To: "Server" }, "*");

            return Data;
        },

        // Получение списка устройств
        List: function () {
            Data = KkmServer.extend({}, KkmServer);

            Data.Command = "List";
            Data.InnKkm = "";
            Data.Active = null;
            Data.OnOff = null;
            Data.OFD_Error = null;
            Data.OFD_DateErrorDoc = '2100-01-01T00:00:00';
            Data.FN_DateEnd = '2100-01-01T00:00:00';
            Data.FN_MemOverflowl = null;
            Data.FN_IsFiscal = null;

            return Data;
        },

        // Возвращает данные для заполнения чека по ФФД вер. 1.1
        GetDataCheck: function (TypeCheck = 0, NumDevice = 0, InnKkm = "", CashierName = "", CashierVATIN = "") {

            Data = KkmServer.extend({}, KkmServer);

            if (CashierName == "" || CashierName == undefined) {
                CashierName = this.DefaultSettings.CashierName;
            }

            // Подготовка данных команды
            Data.VerFFD = "1.0";
            Data.Command = "RegisterCheck";
            Data.NumDevice = NumDevice;
            Data.InnKkm = InnKkm;
            Data.KktNumber = "";
            Data.IsFiscalCheck = true;
            Data.TypeCheck = TypeCheck;
            Data.NotPrint = false;
            Data.NumberCopies = 0;
            Data.CashierName = CashierName;
            Data.CashierVATIN = CashierVATIN;
            Data.ClientAddress = "";
            Data.ClientInfo = null;
            Data.ClientINN = null;
            Data.UserAttribute = null;
            Data.AdditionalAttribute = null;
            Data.SenderEmail = "";
            Data.TaxVariant = "";
            Data.AdditionalProps = [];
            Data.KPP = "";
            Data.ClientId = "";
            Data.KeySubLicensing = "";
            Data.CheckStrings = [];
            Data.Cash = 0;
            Data.ElectronicPayment = 0;
            Data.AdvancePayment = 0;
            Data.Credit = 0;
            Data.CashProvision = 0;

            // Если надо одновременно автоматически провести транзакцию через эквайринг 
            // Эквайринг будет задействован если: 1. чек фискальный, 2. оплата по "ElectronicPayment" не равна 0, 3. PayByProcessing = true
            // null - из настроек kkmserver
            Data.PayByProcessing = null; //В тестовом чеке автоматический эквайринг выключен
            // Номер устройства для эквайринга - Null - из настроек на сервере, 0 - любое, число - номер конкретного устройства
            Data.NumDeviceByProcessing = null; 
            // Номер чека для эквайринга
            Data.ReceiptNumber = "";
            // Печатать Слип-чек после чека (а не в чеке) null - из настроек kkmserver
            Data.PrintSlipAfterCheck = null;
            // Печатать Слип-чек дополнительно для кассира (основной слип-чек уже будет печататся в составе чека) null - из настроек kkmserver
            Data.PrintSlipForCashier = null;
            //Если это чек возврата то возможны два поля для отмены транзакции (если не указано то по эквайрингу будет не отмена а возврат)
            Data.RRNCode = ""; // RRNCode из операции эквайринга. Только для отмены оплаты! Для Оплаты или возврата оплаты не заполнять!
            Data.AuthorizationCode = ""; // AuthorizationCode из операции эквайринга. Только для отмены оплаты! Для Оплаты или возврата оплаты не заполнять!

            // Устаревшее
            Data.CheckProps = [];
            Data.CashLessType1 = 0;
            Data.CashLessType2 = 0;
            Data.CashLessType3 = 0;
            Data.CancelOpenedCheck = true;

            // Добавляет данные агента в чек признак агента
            Data.AddDataAgent = function (
                AgentSign, //признак агента
                PayingAgentOperation = "",
                PayingAgentPhone = "",
                ReceivePaymentsOperatorPhone = "",
                MoneyTransferOperatorPhone = "",
                MoneyTransferOperatorName = "",
                MoneyTransferOperatorAddress = "",
                MoneyTransferOperatorVATIN = "",
                PurveyorPhone = ""
            ) {
                Data.AgentSign = AgentSign;

                if (PayingAgentOperation != ""
                    || PayingAgentPhone != ""
                    || ReceivePaymentsOperatorPhone != ""
                    || MoneyTransferOperatorPhone != ""
                    || MoneyTransferOperatorName != ""
                    || MoneyTransferOperatorAddress != ""
                    || MoneyTransferOperatorVATIN != "") {
                    Data.AgentData = {
                        PayingAgentOperation: PayingAgentOperation,
                        PayingAgentPhone: PayingAgentPhone,
                        ReceivePaymentsOperatorPhone: ReceivePaymentsOperatorPhone,
                        MoneyTransferOperatorPhone: MoneyTransferOperatorPhone,
                        MoneyTransferOperatorName: MoneyTransferOperatorName,
                        MoneyTransferOperatorAddress: MoneyTransferOperatorAddress,
                        MoneyTransferOperatorVATIN: MoneyTransferOperatorVATIN
                    };
                };

                if (PurveyorPhone != "") {
                    Data.PurveyorData = {
                        PurveyorPhone: PurveyorPhone
                    };
                };

                return Data;
            };

            // Добавляет фискальную строку и возвращает ее для заполнения
            Data.AddRegisterString = function (Name, Quantity, Price, Amount, Tax, Department, EAN13, SignMethodCalculation, SignCalculationObject, GoodCodeData = null, MeasurementUnit = "", CountryOfOrigin = null, CustomsDeclaration = null, ExciseAmount = null, AdditionalAttribute = null) {

                var GoodCodeDataObj = null;
                if (GoodCodeData != null && GoodCodeData != undefined) {
                    GoodCodeDataObj = {
                        BarCode: GoodCodeData,
                        ContainsSerialNumber: true
                    };
                };

                var NewData = {
                    Register: {
                        Name: Name,
                        Quantity: Quantity,
                        Price: Price,
                        Amount: Amount,
                        Department: Department,
                        Tax: Tax,
                        EAN13: EAN13,
                        EGAIS: null,
                        SignMethodCalculation: SignMethodCalculation,
                        SignCalculationObject: SignCalculationObject,
                        MeasurementUnit: MeasurementUnit,
                        GoodCodeData: GoodCodeDataObj,
                        AgentSign: null,
                        AgentData: null,
                        PurveyorData: null,
                        CountryOfOrigin: CountryOfOrigin,
                        CustomsDeclaration: CustomsDeclaration,
                        ExciseAmount: ExciseAmount,
                        AdditionalAttribute: AdditionalAttribute
                    }
                };

                if (GoodCodeData == "") {
                    NewData.Register.GoodCodeData = null;
                };
                Data.CheckStrings.push(NewData);
                return NewData.Register;
            };

            // Добавляет в последнею строку Код товарной номенклатуры
            Data.AddGoodCodeData = function (StampType, GTIN, SerialNumber) {
                CheckString = Data.CheckStrings[Data.CheckStrings.length - 1];
                if (CheckString.Register != undefined) {
                    CheckString.Register.GoodCodeData = {
                        StampType: StampType,
                        GTIN: GTIN,
                        SerialNumber: SerialNumber
                    };
                };
                return Data.Register;
            };

            // Добавляет в последнею строку Код товарной номенклатуры
            Data.MarkingCode = function (BarCode, ContainsSerialNumber) {
                CheckString = Data.CheckStrings[Data.CheckStrings.length - 1];
                if (CheckString.Register != undefined) {
                    CheckString.Register.GoodCodeData = {
                        BarCode: BarCode,
                        ContainsSerialNumber: ContainsSerialNumber
                    };
                };
                return Data.Register;
            };

            // Добавляет в последнею строку признак агента
            Data.AddAgentSign = function (AgentSign) {
                CheckString = Data.CheckStrings[Data.CheckStrings.length - 1];
                if (CheckString.Register != undefined) {
                    CheckString.Register.AgentSign = AgentSign;
                };
                return CheckString.Register;
            };

            // Добавляет в последнею строку данные агента
            Data.AddAgentData = function (PayingAgentOperation = "", PayingAgentPhone = "", ReceivePaymentsOperatorPhone = "", MoneyTransferOperatorPhone = "", MoneyTransferOperatorName = "", MoneyTransferOperatorAddress = "", MoneyTransferOperatorVATIN = "") {
                CheckString = Data.CheckStrings[Data.CheckStrings.length - 1];
                if (CheckString.Register != undefined) {
                    CheckString.Register.AgentData = {
                        PayingAgentOperation: PayingAgentOperation,
                        PayingAgentPhone: PayingAgentPhone,
                        ReceivePaymentsOperatorPhone: ReceivePaymentsOperatorPhone,
                        MoneyTransferOperatorPhone: MoneyTransferOperatorPhone,
                        MoneyTransferOperatorName: MoneyTransferOperatorName,
                        MoneyTransferOperatorAddress: MoneyTransferOperatorAddress,
                        MoneyTransferOperatorVATIN: MoneyTransferOperatorVATIN
                    };
                };
                return CheckString.Register;
            };

            // Добавляет в последнею строку данные поставщика
            Data.AddPurveyorData = function (PurveyorPhone, PurveyorName, PurveyorVATIN) {
                CheckString = Data.CheckStrings[Data.CheckStrings.length - 1];
                if (CheckString.Register != undefined) {
                    CheckString.Register.PurveyorData = {
                        PurveyorPhone: PurveyorPhone,
                        PurveyorName: PurveyorName,
                        PurveyorVATIN: PurveyorVATIN
                    };
                };
                return Data.Register;
            };

            // Добавляет простую строку и возвращает ее для заполнения
            Data.AddTextString = function (Text, Font, Intensity) {

                var NewData = {
                    PrintText: {
                        Text: Text,
                        Font: Font,
                        Intensity: Intensity,
                    }
                };

                Data.CheckStrings.push(NewData);
                return NewData.PrintText;

            };

            // Добавляет данные для печати ШК и возвращает ее для заполнения
            Data.AddBarcodeString = function (BarcodeType, Barcode) {

                var NewData = {
                    BarCode: {
                        BarcodeType: BarcodeType,
                        Barcode: Barcode,
                    }
                };

                Data.CheckStrings.push(NewData);
                return NewData.BarCode;

            };

            // Добавляет данные для печати картинки и возвращает ее для заполнения
            Data.AddImageString = function (Image) {

                var NewData = {
                    PrintImage: {
                        Image: Image,
                    },
                };

                Data.CheckStrings.push(NewData);
                return NewData.PrintImage;

            };

            // Добавляет данные по дополнительным тегам
            Data.AddAdditionalProps = function (Print, PrintInHeader, NameProp, Prop) {

                Data.UserAttribute = {
                    // Наименование дополнительного реквизита пользователя тег ОД 1085
                    Name: NameProp,
                    // Значение дополнительного реквизита пользователя тег ОФД 1086
                    Value: Prop
                };

                return Data;

            };

            // Добавляет в последнею строку признак агента
            Data.AddCorrectionDataCheck = function (CorrectionBaseName = "", CorrectionBaseDate = '2001-01-01T00:00:00', CorrectionBaseNumber = "", Ammount = 0, SumTaxNone = 0, SumTax20 = 0, SumTax10 = 0, SumTax0 = 0, SumTax120 = 0, SumTax110 = 0) {
                Data.CorrectionBaseName = CorrectionBaseName;
                Data.CorrectionBaseDate = CorrectionBaseDate;
                Data.CorrectionBaseNumber = CorrectionBaseNumber;
                Data.Ammount = Ammount;
                Data.SumTaxNone = SumTaxNone;
                Data.SumTax20 = SumTax20;
                Data.SumTax10 = SumTax10;
                Data.SumTax0 = SumTax0;
                Data.SumTax120 = SumTax120;
                Data.SumTax110 = SumTax110;
                return Data;
            };

            for (var i = 0; i < this.DefaultSettings.CheckProps.length; i++) {
                var Prop = this.DefaultSettings.CheckProps[i];
                Data.AddCheckProps(Prop.Print, Prop.PrintInHeader, Prop.Teg, Prop.Prop);
            };

            return Data;
        },

        // Возвращает данные для заполнения чека по ФФД вер. 1.0
        GetDataCheck_1_0: function (TypeCheck = 0, NumDevice = 0, InnKkm = "", CashierName = "") {

            return KkmServer.GetDataCheck(TypeCheck, NumDevice, InnKkm, CashierName);

        },

        OpenShift: function (NumDevice = 0, CashierName = "", CashierVATIN = "") {

            Data = KkmServer.extend({}, KkmServer);

            Data.Command = "OpenShift";
            Data.NumDevice = NumDevice;
            Data.CashierName = CashierName;
            Data.CashierVATIN = CashierVATIN;

            return Data;
        },

        CloseShift: function (NumDevice = 0, CashierName = "", CashierVATIN = "") {

            Data = KkmServer.extend({}, KkmServer);
            Data.Command = "CloseShift";
            Data.NumDevice = NumDevice;
            Data.CashierName = CashierName;
            Data.CashierVATIN = CashierVATIN;

            return Data;
        },

        ZReport: function (NumDevice = 0, CashierName = "", CashierVATIN = "") {

            Data = KkmServer.extend({}, KkmServer);
            Data.Command = "CloseShift";
            Data.NumDevice = NumDevice;
            Data.CashierName = CashierName;
            Data.CashierVATIN = CashierVATIN;

            return Data;
        },

        XReport: function (NumDevice = 0) {

            Data = KkmServer.extend({}, KkmServer);
            Data.Command = "XReport";
            Data.NumDevice = NumDevice;
            return Data;
        },

        OfdReport: function (NumDevice = 0) {

            Data = KkmServer.extend({}, KkmServer);
            Data.Command = "OfdReport";
            Data.NumDevice = NumDevice;
            return Data;
        },

        OpenCashDrawer: function (NumDevice = 0) {

            Data = KkmServer.extend({}, KkmServer);
            Data.Command = "OpenCashDrawer";
            Data.NumDevice = NumDevice;

            return Data;
        },

        DepositingCash: function (NumDevice = 0, Amount = 0, CashierName = "", CashierVATIN = "") {

            Data = KkmServer.extend({}, KkmServer);
            Data.Command = "DepositingCash";
            Data.NumDevice = NumDevice;
            Data.Amount = Amount;
            Data.CashierName = CashierName;
            Data.CashierVATIN = CashierVATIN;

            return Data;
        },

        PaymentCash: function (NumDevice = 0, Amount = 0, CashierName = "", CashierVATIN = "") {

            Data = KkmServer.extend({}, KkmServer);
            Data.Command = "PaymentCash";
            Data.NumDevice = NumDevice;
            Data.Amount = Amount;
            Data.CashierName = CashierName;
            Data.CashierVATIN = CashierVATIN;

            return Data;
        },

        GetDataForCheck: function (NumDevice = 0, FiscalNumber = 0, NumberCopies = 0) {

            Data = KkmServer.extend({}, KkmServer);
            Data.Command = "GetDataCheck";
            Data.NumDevice = NumDevice;
            Data.FiscalNumber = FiscalNumber;
            Data.NumberCopies = NumberCopies;
            return Data;
        },

        GetDataKKT: function (NumDevice = 0) {

            Data = KkmServer.extend({}, KkmServer);
            Data.Command = "GetDataKKT";
            Data.NumDevice = NumDevice;

            return Data;
        },

        GetRezult: function (IdCommand) {

            Data = KkmServer.extend({}, KkmServer);
            Data.Command = "GetRezult";
            Data.IdCommand = IdCommand;

            return Data;
        },

        // Добавление дополнительных свойст чека по умолчанию
        AddDefaultCheckProps: function (Print, PrintInHeader, Teg, Prop) {

            var Data = {
                Print: Print,
                PrintInHeader: PrintInHeader,
                Teg: Teg,
                Prop: Prop
            };

            this.DefaultSettings.CheckProps.push(Data);
            return Data;

        },

        // Добаляет прослушиватель для сканера штрих-кодов
        // Параметр: Fun(Data), где Data - объект: {BarCode, NumDevice, UnitName, AlreadyProcessed}
        //      Где: BarCode - строка, отсканированный штрих-код
        //      Где: NumDevice - строка, номер устройства
        //      Где: UnitName - строка, пользовательское имя устройства
        //      Где: AlreadyProcessed - bool, возвращаемый, если установит в Истина то расширение считает что ШК обработан и не вызывает дальше прослушиватели 
        addEventBarcodeListener: function (Fun) {
            KkmServer._ListBarCodeEvent.add(Fun);
        },

        // ------------------------------------------------------------------------------------
        //  КОМАНДЫ ЭКВАЙРИНГОВЫЕ ТЕРМИНАЛЫ (Только для продуктов серии UnitServer !!!!)

        // Оплатить платежной картой
        PayByPaymentCard: function (NumDevice = 0, Amount) {

            Data = KkmServer.extend({}, KkmServer);

            // Команда серверу
            Data.Command = "PayByPaymentCard";
            // Номер устройства. Если 0 то первое не блокированное на сервере
            Data.NumDevice = NumDevice;
            // Сумма оплаты
            Data.Amount = Amount;
            return Data;
        },

        // Вернуть платеж по платежной карте
        ReturnPaymentByPaymentCard: function (NumDevice = 0, Amount, UniversalID = "") {

            Data = KkmServer.extend({}, KkmServer);

            // Команда серверу
            Data.Command = "ReturnPaymentByPaymentCard";
            // Номер устройства. Если 0 то первое не блокированное на сервере
            Data.NumDevice = NumDevice;
            // Сумма оплаты
            Data.Amount = Amount;
            // Идентификатор транзакции
            Data.UniversalID = UniversalID;
            return Data;

        },

        // Отменить платеж по платежной карте
        CancelPaymentByPaymentCard: function (NumDevice = 0, Amount, UniversalID = "") {

            Data = KkmServer.extend({}, KkmServer);

            // Команда серверу
            Data.Command = "CancelPaymentByPaymentCard";
            // Номер устройства. Если 0 то первое не блокированное на сервере
            Data.NumDevice = NumDevice;
            // Сумма оплаты
            Data.Amount = Amount;
            // Идентификатор транзакции
            Data.UniversalID = UniversalID;
            return Data;

        },

        // Аварийная отмена операции (Метод отменяет последнюю транзакцию)
        EmergencyReversal: function (NumDevice = 0, UniversalID = "") {

            Data = KkmServer.extend({}, KkmServer);

            // Команда серверу
            Data.Command = "EmergencyReversal";
            // Номер устройства. Если 0 то первое не блокированное на сервере
            Data.NumDevice = NumDevice;
            // Идентификатор транзакции
            Data.UniversalID = UniversalID;
            return Data;

        },

        // Получить итоги дня по картам (Закрытие смены на терминале)
        Settlement: function (NumDevice = 0) {

            Data = KkmServer.extend({}, KkmServer);

            // Команда серверу
            Data.Command = "Settlement";
            // Номер устройства. Если 0 то первое не блокированное на сервере
            Data.NumDevice = NumDevice;
            return Data;

        },

        // Получить отчет по итогам дня по картам
        TerminalReport: function (NumDevice = 0, Detailed = false) {

            Data = KkmServer.extend({}, KkmServer);

            // Команда серверу
            Data.Command = "TerminalReport";
            // Номер устройства. Если 0 то первое не блокированное на сервере
            Data.NumDevice = NumDevice;
            // Краткий (false) или полный (true) отчет
            Detailed: Detailed;
            return Data;

        },

        // Получить копию слип-чека
        TransactionDetails: function (NumDevice = 0, Amount, RRNCode, AuthorizationCode, CardNumber) {

            Data = KkmServer.extend({}, KkmServer);

            // Команда серверу
            Data.Command = "TransactionDetails";
            // Номер устройства. Если 0 то первое не блокированное на сервере
            Data.NumDevice = NumDevice;
            // Номер Карты / Данные карты - если карта считывается устройством то не заполняется
            Data.CardNumber = CardNumber;
            // Сумма оплаты
            Data.Amount = Amount;
            // Уникальный код транзакции RRN который был получен при оплате картой
            Data.RRNCode = RRNCode;
            // Код авторизации транзакции который был получен при оплате картой
            Data.AuthorizationCode = AuthorizationCode;
            return Data;

        },

        // ------------------------------------------------------------------------------------

        // Копирование свойств
        extend: function (dest, src, overwrite = true, skip_ = false) {
            for (var i in src) {
                if (skip_ == true && (i.indexOf("_") == 0 || typeof src[i] == "function" || i == "DefaultSettings")) {
                    continue;
                };
                if (overwrite == false && dest.hasOwnProperty(i) == true) {
                    continue;
                };
                dest[i] = src[i];
            };
            return dest;
        },

        // Герерация GUID
        NewGuid: function () {
            function S4() {
                return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
            };
            return (S4() + S4() + "-" + S4() + "-" + S4() + "-" + S4() + "-" + S4() + S4() + S4());
        },

        CloseMessageWindows: function (Id) {
            //debugger;
            var elem = document.getElementById(Id);
            if (elem != null) {
                elem.parentNode.removeChild(elem);
            };
        },

        CancelCommand: function (NumDevice) {
            //debugger;
            if (NumDevice == null || NumDevice == undefined || NumDevice == 0) {
                return;
            };
            var elem = document.getElementById("KkmServerCancelCommand");
            if (elem != null) {
                elem.innerHTML = "Отменяем операцию...";
            };
            KkmServer.Execute(undefined,
                {
                    Command: "CancelCommand",
                    NumDevice: NumDevice
                }
            );
        },

    };

    // Принимаем выполнение команды от KkmServer
    window.addEventListener("message", function (event) {
        if (event.source != window || event.data.To != "Client") return;
        var IdCommand = event.data.Data.IdCommand;
        if (event.data.Data.Command == "GetRezult") {
            IdCommand = event.data.Data.Rezult.IdCommand + "GetRezult"; 
        };
        if (KkmServer._QueryResponses.has(IdCommand) == true) {
            try {
                CallBack = KkmServer._QueryResponses.get(IdCommand);
                CallBack(event.data.Data);
                KkmServer._QueryResponses.delete(IdCommand);
                //
            } catch (err) { };
            IsRun = false;
        };
    }, false);

    // Слушаем сообщения о сканировании штрих-кодов
    window.addEventListener("message",
        function (event) {

            if (event.source != window || event.data.name != "kkmserver.addin.EventBarcode") return;

            var AlreadyProcessed = false;
            for (let Fun of KkmServer._ListBarCodeEvent) {
                try {
                    var Par = { BarCode: event.data.BarCode, NumDevice: event.data.NumDevice, UnitName: event.data.UnitName, AlreadyProcessed: AlreadyProcessed };
                    Fun(Par);
                    AlreadyProcessed = Par.AlreadyProcessed;
                    if (AlreadyProcessed == true) {
                        break;
                    };
                } catch (ex) { };
            };
        }
    );

    // Слушаем сообщения о откытии окна сообщения
    window.addEventListener("message",
        function (event) {

            if (event.source != window || event.data.name != "kkmserver.addin.ShowMessage") return;

            // Удаляем старый элемент если был.
            var elem = document.getElementById("kkmserver.addin.ShowMessage");
            if (elem.length > 0) {
                elem.parentNode.removeChild(elem);
            };

            //Добавляем новый элемент
            var ItemBody = document.getElementsByTagName("body")[i];
            ItemBody.appendChild(event.data.MessageHTML);

        }, false
    );

}


///////////////////////////////////////////////////////////////////
//-СТАРОЕ - Только для совместимости. Не используйте эти функции
///////////////////////////////////////////////////////////////////


// Выполняет команду на KkmServer
function KkmServer_Execute(Data, CallBack) {

    if ("IdCommand" in Data == false) {
        Data.IdCommand = guid();
    };
    if (Data.IdCommand == "") {
        Data.IdCommand = guid();
    };

    KkmServer._QueryResponses.set(Data.IdCommand, CallBack);

    window.postMessage({ Data: Data, To: "Server" }, "*");

}

// Получение списка устройств
function KkmServer_List() {

    Data = {
        Command: "List",
        NumDevice: 0,
        IdCommand: KkmServer_NewGuid(),
        InnKkm: "",
        Active: null,
        OnOff: null,
        OFD_Error: null,
        OFD_DateErrorDoc: '2100-01-01T00:00:00',
        FN_DateEnd: '2100-01-01T00:00:00',
        FN_MemOverflowl: null,
        FN_IsFiscal: null
    };

    return Data;
}

// Включение/выключение устройства
function KkmServer_OnOffUnut(NumDevice = 0, Active = false) {

    Data = {
        Command: "OnOffUnut",
        NumDevice: NumDevice,
        Active: Active,
        IdCommand: KkmServer_NewGuid(),
    };

    return Data;
}

// Герерация GUID
function KkmServer_NewGuid() {

    function S4() {
        return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
    }

    return (S4() + S4() + "-" + S4() + "-" + S4() + "-" + S4() + "-" + S4() + S4() + S4());
}

//////////////////////////////////////////////////////////
//-ККТ----------------------------------------------------
//////////////////////////////////////////////////////////

// Возвращает данные для заполнения чека по ФФД вер. 1.0
function KkmServer_GetDataCheck_1_0(TypeCheck = 0, NumDevice = 0, InnKkm = "", CashierName = "") {

    // Подготовка данных команды
    var Data = {
        VerFFD: "1.0",
        Command: "RegisterCheck",
        NumDevice: NumDevice,
        InnKkm: InnKkm,
        KktNumber: "",
        Timeout: 30,
        IdCommand: KkmServer_NewGuid(),
        IsFiscalCheck: true,
        TypeCheck: TypeCheck,
        CancelOpenedCheck: true,
        NotPrint: false,
        NumberCopies: 0,
        CashierName: CashierName,
        ClientAddress: "",
        TaxVariant: "",
        CheckProps: [],
        AdditionalProps: [],
        KPP: "",
        ClientId: "",
        KeySubLicensing: "",
        CheckStrings: [],
        Cash: 0,
        CashLessType1: 0,
        CashLessType2: 0,
        CashLessType3: 0
    };

    return Data;
}

// Добаляет фискальную строку и возвращает ее для заполнения
function KkmServer_AddRegisterString(DataCheck, Name, Quantity, Price, Amount, Tax, Department, EAN13, SignMethodCalculation, SignCalculationObject, GoodCodeData, MeasurementUnit) {

    var Data;

    if (DataCheck.VerFFD == "1.0") {
        Data = {
            Register: {
                Name: Name,
                Quantity: Quantity,
                Price: Price,
                Amount: Amount,
                Department: Department,
                Tax: Tax,
                EAN13: EAN13,
                EGAIS: null,
            }
        }
    };

    DataCheck.CheckStrings.push(Data);
    return Data.Register;

}

// Добаляет простую строку и возвращает ее для заполнения
function KkmServer_AddTextString(DataCheck, Text, Font, Intensity) {

    var Data;

    Data = {
        PrintText: {
            Text: Text,
            Font: Font,
            Intensity: Intensity,
        }
    };

    DataCheck.CheckStrings.push(Data);
    return Data.PrintText;

}

// Добаляет данные для печати ШК и возвращает ее для заполнения
function KkmServer_AddBarcodeString(DataCheck, BarcodeType, Barcode) {

    var Data;

    Data = {
        BarCode: {
            BarcodeType: BarcodeType,
            Barcode: Barcode,
        }
    };

    DataCheck.CheckStrings.push(Data);
    return Data.BarCode;

}

// Добаляет данные для печати картинки и возвращает ее для заполнения
function KkmServer_AddImageString(DataCheck, Image) {

    var Data;

    Data = {
        PrintImage: {
            Image: Image,
        },
    };

    DataCheck.CheckStrings.push(Data);
    return Data.PrintImage;

}

//--------------------------------------------------------

function KkmServer_OpenShift(NumDevice = 0, CashierName = "") {

    Data = {
        Command: "OpenShift",
        NumDevice: NumDevice,
        CashierName: CashierName,
        IdCommand: KkmServer_NewGuid(),
    };

    return Data;
}

function KkmServer_CloseShift(NumDevice = 0, CashierName = "") {

    Data = {
        Command: "CloseShift",
        NumDevice: NumDevice,
        CashierName: CashierName,
        IdCommand: KkmServer_NewGuid(),
    };
    return Data;
}

function KkmServer_ZReport(NumDevice = 0, CashierName = "") {

    Data = {
        Command: "CloseShift",
        NumDevice: NumDevice,
        CashierName: CashierName,
        IdCommand: KkmServer_NewGuid(),
    };
    return Data;
}

function KkmServer_XReport(NumDevice = 0) {

    Data = {
        Command: "XReport",
        NumDevice: NumDevice,
        IdCommand: KkmServer_NewGuid(),
    };
    return Data;
}

function KkmServer_OfdReport(NumDevice = 0) {

    Data = {
        Command: "OfdReport",
        NumDevice: NumDevice,
        IdCommand: KkmServer_NewGuid(),
    };
    return Data;
}

function KkmServer_OpenCashDrawer(NumDevice = 0) {

    Data = {
        Command: "OpenCashDrawer",
        NumDevice: NumDevice,
        IdCommand: KkmServer_NewGuid(),
    };
    return Data;
}

function KkmServer_DepositingCash(NumDevice = 0, Amount = 0, CashierName = "") {

    Data = {
        Command: "DepositingCash",
        NumDevice: NumDevice,
        Amount: Amount,
        CashierName: CashierName,
        IdCommand: KkmServer_NewGuid(),
    };
    return Data;
}

function KkmServer_PaymentCash(NumDevice = 0, Amount = 0, CashierName = "") {

    Data = {
        Command: "PaymentCash",
        NumDevice: NumDevice,
        Amount: Amount,
        CashierName: CashierName,
        IdCommand: KkmServer_NewGuid(),
    };
    return Data;
}

function KkmServer_GetDataKKT(NumDevice = 0) {

    Data = {
        Command: "GetDataKKT",
        NumDevice: NumDevice,
        IdCommand: KkmServer_NewGuid(),
    };
    return Data;
}

function KkmServer_GetRezult(IdCommand) {

    Data = {
        Command: "GetRezult",
        IdCommand: IdCommand,
    };
    return Data;
}

//////////////////////////////////////////////////////////
//-ШК-----------------------------------------------------
//////////////////////////////////////////////////////////

// Добаляет прослушиватель для сканера штрих-кодов
// Параметр: Fun(Data), где Data - объект: {BarCode, NumDevice, UnitName, AlreadyProcessed}
//      Где: BarCode - строка, отсканированный штрих-код
//      Где: NumDevice - строка, номер устройства
//      Где: UnitName - строка, пользовательское имя устройства
//      Где: AlreadyProcessed - bool, возвращаемый, если установить в Истина то расширение считает что ШК обработан и не вызывает дальше прослушиватели 
function KkmServer_addEventBarcodeListener(Fun) {
    KkmServer.addEventBarcodeListener(Fun);
}


//////////////////////////////////////////////////////////
//-Вспомогательное----------------------------------------
//////////////////////////////////////////////////////////

// Герерация GUID
function guid() {

    function S4() {
        return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
    }

    return (S4() + S4() + "-" + S4() + "-" + S4() + "-" + S4() + "-" + S4() + S4() + S4());
}


`;



// При загрузке страницы внедряем скрипт
document.addEventListener("DOMContentLoaded",
    
    function (event) {
        // Перебираем head
        var IsAppend = false;
        for (var i = 0; i < document.getElementsByTagName("head").length; i++) {
            var ItemHead = document.getElementsByTagName("head")[i];
            for (var y = 0; y < ItemHead.children.length; y++) {
                var ItemHeadChild = ItemHead.children[y];
                if (ItemHeadChild.innerHTML.toUpperCase().indexOf("KkmServerAddIn".toUpperCase()) != -1) {
                    var script = document.createElement("script");
                    script.setAttribute("type", "text/javascript");
                    script.innerHTML = TextScript;
                    document.getElementsByTagName("head")[0].appendChild(script);
                    IsAppend = true;
                    break;
                };
            };
            if (IsAppend == true) break;
        };
        //
        if (IsAppend == false) {
            var script = document.createElement("script");
            script.setAttribute("type", "text/javascript");
            script.innerHTML = TextScript;
            document.getElementsByTagName("head")[0].appendChild(script);
        };
        //
    }

);

// Слушаем сообщения со страницы из внедренного скрипта
window.addEventListener("message",
    function (event) {
        if (event.source == window && event.data.To == "Server") {

            //
            //
            var Port = browser.runtime.connect({ name: "kkmserver.addin" });
            //
            Port.postMessage(event.data.Data);
            Port.onMessage.addListener(AddInKkmServerContent.MessageFromKkmserverAddin);

            //AddInKkmServerContent.MonitoringCommand(event.data.Data.IdCommand, Port, true, event.data.Data.Command);

        };
    } 
);

// Слушаем сообщения от расширения на активную страницу
chrome.runtime.onMessage.addListener(
    function (request, sender, sendResponse) {

        if (request.name == "kkmserver.addin.EventBarcode") {
            window.postMessage({ name: "kkmserver.addin.EventBarcode", BarCode: request.message.Event.Data, NumDevice: request.message.Event.Source }, "*");
        };

    }
);


AddInKkmServerContent = {

    QueryResponses: new Map(),

    //Сообщения от расширения по открытому командой порту
    MessageFromKkmserverAddin: function (message, Port) {

        if (message.Messages != undefined) { // массив сообщений

            message.Messages.forEach(element => {

                if (element.name != undefined && element.name == "kkmserver.addin.ShowWindows") {

                    // Удаляем старое окно сообщения если было.
                    var elem = document.getElementById("kkmserver.addin.ShowWindows." + element.TypeWindows);
                    if (elem != null) {
                        elem.parentNode.removeChild(elem);
                    };

                    //Добавляем новое окно сообщения
                    var div = document.createElement("div");
                    div.setAttribute("id", "kkmserver.addin.ShowWindows." + element.TypeWindows);
                    MessageHTML = element.MessageHTML;
                    MessageHTML = MessageHTML.replace("_TypeWindows_", element.TypeWindows);
                    div.innerHTML = MessageHTML;
                    var ItemBody = document.getElementsByTagName("body")[0];
                    ItemBody.appendChild(div);

                    //if (element.TypeWindows == "TrackingStatus") {
                    //    AddInKkmServerContent.MonitoringCommand(element.IdCommand, Port, false, "");
                    //};

                } else if (element.name != undefined && element.name == "kkmserver.addin.CloseWindows") {

                        // Удаляем старое окно сообщения если было.
                        var elem = document.getElementById("kkmserver.addin.ShowWindows." + element.TypeWindows);
                        if (elem != null) {
                            elem.parentNode.removeChild(elem);
                        };

                } else if (element.Command != undefined && element.Command == "UseAddInDialog") {

                    // Удаляем старое окно сообщения если было.
                    var elem = document.getElementById("kkmserver.addin.ShowWindows.AddInDialog");
                    if (elem != null) {
                        elem.parentNode.removeChild(elem);
                    };
                    var elem = document.getElementById("kkmserver.addin.ShowWindows.AddInDialog");
                    if (elem != null) {
                        elem.parentNode.removeChild(elem);
                    };

                    //Добавляем новое окно сообщения
                    var div = document.createElement("div");
                    div.setAttribute("id", "kkmserver.addin.ShowWindows.AddInDialog");
                    MessageHTML = element.UseAddInDialogHTML;
                    div.innerHTML = MessageHTML;
                    var ItemBody = document.getElementsByTagName("body")[0];
                    ItemBody.appendChild(div);

                    //Добавляем скрипт
                    var script = document.createElement("script");
                    script.setAttribute("id", "kkmserver.addin.ShowWindows.AddInDialog");
                    script.setAttribute("type", "text/javascript");
                    script.setAttribute("charset", "utf-8");
                    TextScript = element.UseAddInDialogScript;
                    script.innerHTML = TextScript;
                    document.getElementsByTagName("head")[0].appendChild(script);

                } else { // Отправляем ответ на команду
                    if (element.MessageTo != undefined && element.MessageTo != null) {
                        window.postMessage({ Data: element, To: element.MessageTo }, "*");
                    } else {
                        window.postMessage({ Data: element, To: "Client" }, "*");
                    }
                };

            });

        } else {
            if (message.MessageTo != undefined && message.MessageTo != null) {
                window.postMessage({ Data: message, To: message.MessageTo }, "*");
            } else {
                window.postMessage({ Data: message, To: "Client" }, "*");
            }
        };
    },

    // Мониторим команду на сообщения для показа на экране
    MonitoringCommand: function (IdCommand, Port, Add = false, Command = "") {

        //if (Add == true) {
        //    if (this.TypeCommand(Command) == undefined) {
        //        return;
        //    };
        //    this.QueryResponses.set(IdCommand, Port);
        //};

        //Port = this.QueryResponses.get(IdCommand);
        //if (Port == undefined) {
        //    return;
        //};

        //let timerId = setTimeout(() => {
        //    CommandShowMessage = {
        //        Command: "TrackingStatusCommand",
        //        IdCommand: IdCommand
        //    };
        //    Port.postMessage(CommandShowMessage);
        //}, 1000);

    },
    
    // Мониторим команду на сообщения для показа на экране
    TypeCommand: function (Command) {

        ////Устанавливаем значения по умолчанию
        //if (Command == "RegisterCheck"
        //    || Command == "OpenShift"
        //    || Command == "CloseShift"
        //    || Command == "XReport"
        //    || Command == "ZReport"
        //    || Command == "DepositingCash"
        //    || Command == "KkmRegOfd") {
        //    return "Check";
        //};

        //if (Command == "PaymentCash"
        //    || Command == "KkmRegOfd"
        //    || Command == "PayByPaymentCard"
        //    || Command == "ReturnPaymentByPaymentCard"
        //    || Command == "CancelPaymentByPaymentCard"
        //    || Command == "AuthorisationByPaymentCard"
        //    || Command == "AuthConfirmationByPaymentCard"
        //    || Command == "CancelAuthorisationByPaymentCard"
        //    || Command == "EmergencyReversal"
        //    || Command == "TerminalReport"
        //    || Command == "TransactionDetails"
        //    || Command == "Settlement") {
        //    return "Pay";
        //}

        //if (Command == "PrintDocument") {
        //    return "Print";
        //};

        //if (Command == "GetWeight") {
        //    return "Libra";
        //};

        //return undefined;

    }

}

